#ifndef ATOMS_H
#define ATOMS_H

enum tag_t {
	TAG_COOKIE,
	TAG_VALUE
};
typedef struct {
	enum tag_t tag;
	union {
		XCBInternAtomCookie cookie;
		XCBATOM atom;
	} u;
} InternAtomFastCookie;

XCBATOM InternAtomPredefined(CARD16 name_len, const char *name);
InternAtomFastCookie InternAtomFast(XCBConnection *c, BOOL only_if_exists, CARD16 name_len, const char *name);
XCBATOM InternAtomFastReply(XCBConnection *c, InternAtomFastCookie cookie, XCBGenericError **e);

const char *GetAtomNamePredefined(XCBATOM atom);
int GetAtomName(XCBConnection *c, XCBATOM atom, const char **namep, int *lengthp);

extern const XCBATOM PRIMARY;
extern const XCBATOM SECONDARY;
extern const XCBATOM ARC;
extern const XCBATOM ATOM;
extern const XCBATOM BITMAP;
extern const XCBATOM CARDINAL;
extern const XCBATOM COLORMAP;
extern const XCBATOM CURSOR;
extern const XCBATOM CUT_BUFFER0;
extern const XCBATOM CUT_BUFFER1;
extern const XCBATOM CUT_BUFFER2;
extern const XCBATOM CUT_BUFFER3;
extern const XCBATOM CUT_BUFFER4;
extern const XCBATOM CUT_BUFFER5;
extern const XCBATOM CUT_BUFFER6;
extern const XCBATOM CUT_BUFFER7;
extern const XCBATOM DRAWABLE;
extern const XCBATOM FONT;
extern const XCBATOM INTEGER;
extern const XCBATOM PIXMAP;
extern const XCBATOM POINT;
extern const XCBATOM RECTANGLE;
extern const XCBATOM RESOURCE_MANAGER;
extern const XCBATOM RGB_COLOR_MAP;
extern const XCBATOM RGB_BEST_MAP;
extern const XCBATOM RGB_BLUE_MAP;
extern const XCBATOM RGB_DEFAULT_MAP;
extern const XCBATOM RGB_GRAY_MAP;
extern const XCBATOM RGB_GREEN_MAP;
extern const XCBATOM RGB_RED_MAP;
extern const XCBATOM STRING;
extern const XCBATOM VISUALID;
extern const XCBATOM WINDOW;
extern const XCBATOM WM_COMMAND;
extern const XCBATOM WM_HINTS;
extern const XCBATOM WM_CLIENT_MACHINE;
extern const XCBATOM WM_ICON_NAME;
extern const XCBATOM WM_ICON_SIZE;
extern const XCBATOM WM_NAME;
extern const XCBATOM WM_NORMAL_HINTS;
extern const XCBATOM WM_SIZE_HINTS;
extern const XCBATOM WM_ZOOM_HINTS;
extern const XCBATOM MIN_SPACE;
extern const XCBATOM NORM_SPACE;
extern const XCBATOM MAX_SPACE;
extern const XCBATOM END_SPACE;
extern const XCBATOM SUPERSCRIPT_X;
extern const XCBATOM SUPERSCRIPT_Y;
extern const XCBATOM SUBSCRIPT_X;
extern const XCBATOM SUBSCRIPT_Y;
extern const XCBATOM UNDERLINE_POSITION;
extern const XCBATOM UNDERLINE_THICKNESS;
extern const XCBATOM STRIKEOUT_ASCENT;
extern const XCBATOM STRIKEOUT_DESCENT;
extern const XCBATOM ITALIC_ANGLE;
extern const XCBATOM X_HEIGHT;
extern const XCBATOM QUAD_WIDTH;
extern const XCBATOM WEIGHT;
extern const XCBATOM POINT_SIZE;
extern const XCBATOM RESOLUTION;
extern const XCBATOM COPYRIGHT;
extern const XCBATOM NOTICE;
extern const XCBATOM FONT_NAME;
extern const XCBATOM FAMILY_NAME;
extern const XCBATOM FULL_NAME;
extern const XCBATOM CAP_HEIGHT;
extern const XCBATOM WM_CLASS;
extern const XCBATOM WM_TRANSIENT_FOR;

#endif /* ATOMS_H */
